var BOOK_Device =
{
	new : func(designation, model_element, model_index=0)
	{
        var obj = {parents : [BOOK_Device] };
        obj.designation = designation;
        obj.model_element = model_element;
		obj.my_canvas = canvas.new({
			"name": designation,   # The name is optional but allow for easier identification
			"size": [1024, 1024], # Size of the underlying texture (should be a power of 2, required) [Resolution]
			"view": [400, 550],  # Virtual resolution (Defines the coordinate system of the canvas [Dimensions]
			"mipmapping": 0       # Enable mipmapping (optional)
		});
		obj.my_canvas.addPlacement({"node": "BookCanvas"});
		obj.my_canvas.set("background", "#f0f0f0");

		obj.root = obj.my_canvas.createGroup();

		var filename = "/Aircraft/L70/Instruments/Book/Book.svg";
		obj.svg_symbol = obj.root.createChild('group');
		canvas.parsesvg(obj.svg_symbol, filename);
		obj.StdGesamt = obj.svg_symbol.getElementById("StdGesamt");
		obj.StdEng1 = obj.svg_symbol.getElementById("StdEng1");
		obj.StdEng2 = obj.svg_symbol.getElementById("StdEng2");
		obj.StdEng3 = obj.svg_symbol.getElementById("StdEng3");
		obj.StdEng4 = obj.svg_symbol.getElementById("StdEng4");
		obj.StdEng5 = obj.svg_symbol.getElementById("StdEng5");
		obj.StdEng6 = obj.svg_symbol.getElementById("StdEng6");
		obj.StdFlug = obj.svg_symbol.getElementById("StdFlug");
		obj.DutyHull = obj.svg_symbol.getElementById("DutyHull");
		obj.DutyMot1 = obj.svg_symbol.getElementById("DutyMot1");
		obj.DutyMot2 = obj.svg_symbol.getElementById("DutyMot2");
		obj.DutyMot3 = obj.svg_symbol.getElementById("DutyMot3");
		obj.DutyMot4 = obj.svg_symbol.getElementById("DutyMot4");
		obj.DutyMot5 = obj.svg_symbol.getElementById("DutyMot5");
		obj.DutyMot6 = obj.svg_symbol.getElementById("DutyMot6");
		obj.DutyIndHull = obj.svg_symbol.getElementById("DutyIndHull");
		obj.DutyIndHull.hide();
		obj.ButtonWartHuelle = obj.svg_symbol.getElementById("ButtonWartHuelle");
		obj.ButtonWartHuelle.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/hull/dutyc", 0);
		});
		obj.ButtonWartHuelle.addEventListener("mouseover", func {
			obj.ButtonWartHuelle.setColor(255, 0, 0);
			obj.ButtonWartHuelle.update();
		});
		obj.ButtonWartHuelle.addEventListener("mouseout", func {
			obj.ButtonWartHuelle.setColor(0, 0, 0);
			obj.ButtonWartHuelle.update();
		});
		obj.ButtonWartHuelle.hide();

		obj.DutyIndMot1 = obj.svg_symbol.getElementById("DutyIndMot1");
		obj.DutyIndMot1.hide();
		obj.DutyIndMot2 = obj.svg_symbol.getElementById("DutyIndMot2");
		obj.DutyIndMot2.hide();
		obj.DutyIndMot3 = obj.svg_symbol.getElementById("DutyIndMot3");
		obj.DutyIndMot3.hide();
		obj.DutyIndMot4 = obj.svg_symbol.getElementById("DutyIndMot4");
		obj.DutyIndMot4.hide();
		obj.DutyIndMot5 = obj.svg_symbol.getElementById("DutyIndMot5");
		obj.DutyIndMot5.hide();
		obj.DutyIndMot6 = obj.svg_symbol.getElementById("DutyIndMot6");
		obj.DutyIndMot6.hide();
		obj.ButtonWartMot1 = obj.svg_symbol.getElementById("ButtonWartMot1");
		obj.ButtonWartMot1.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/engine[0]/dutyc", 0);
		});
		obj.ButtonWartMot1.addEventListener("mouseover", func {
			obj.ButtonWartMot1.setColor(255, 0, 0);
			obj.ButtonWartMot1.update();
		});
		obj.ButtonWartMot1.addEventListener("mouseout", func {
			obj.ButtonWartMot1.setColor(0, 0, 0);
			obj.ButtonWartMot1.update();
		});
		obj.ButtonWartMot1.hide();

		obj.ButtonWartMot2 = obj.svg_symbol.getElementById("ButtonWartMot2");
		obj.ButtonWartMot2.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/engine[1]/dutyc", 0);
		});
		obj.ButtonWartMot2.addEventListener("mouseover", func {
			obj.ButtonWartMot2.setColor(255, 0, 0);
			obj.ButtonWartMot2.update();
		});
		obj.ButtonWartMot2.addEventListener("mouseout", func {
			obj.ButtonWartMot2.setColor(0, 0, 0);
			obj.ButtonWartMot2.update();
		});
		obj.ButtonWartMot2.hide();
		
		obj.ButtonWartMot3 = obj.svg_symbol.getElementById("ButtonWartMot3");
		obj.ButtonWartMot3.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/engine[2]/dutyc", 0);
		});
		obj.ButtonWartMot3.addEventListener("mouseover", func {
			obj.ButtonWartMot3.setColor(255, 0, 0);
			obj.ButtonWartMot3.update();
		});
		obj.ButtonWartMot3.addEventListener("mouseout", func {
			obj.ButtonWartMot3.setColor(0, 0, 0);
			obj.ButtonWartMot3.update();
		});
		obj.ButtonWartMot3.hide();

		obj.ButtonWartMot4 = obj.svg_symbol.getElementById("ButtonWartMot4");
		obj.ButtonWartMot4.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/engine[3]/dutyc", 0);
		});
		obj.ButtonWartMot4.addEventListener("mouseover", func {
			obj.ButtonWartMot4.setColor(255, 0, 0);
			obj.ButtonWartMot4.update();
		});
		obj.ButtonWartMot4.addEventListener("mouseout", func {
			obj.ButtonWartMot4.setColor(0, 0, 0);
			obj.ButtonWartMot4.update();
		});
		obj.ButtonWartMot4.hide();

		obj.ButtonWartMot5 = obj.svg_symbol.getElementById("ButtonWartMot5");
		obj.ButtonWartMot5.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/engine[4]/dutyc", 0);
		});
		obj.ButtonWartMot5.addEventListener("mouseover", func {
			obj.ButtonWartMot5.setColor(255, 0, 0);
			obj.ButtonWartMot5.update();
		});
		obj.ButtonWartMot5.addEventListener("mouseout", func {
			obj.ButtonWartMot5.setColor(0, 0, 0);
			obj.ButtonWartMot5.update();
		});
		obj.ButtonWartMot5.hide();

		obj.ButtonWartMot6 = obj.svg_symbol.getElementById("ButtonWartMot6");
		obj.ButtonWartMot6.addEventListener("click", func {
			setprop("/sim/model/L70/hobbs-meter/engine[5]/dutyc", 0);
		});
		obj.ButtonWartMot6.addEventListener("mouseover", func {
			obj.ButtonWartMot6.setColor(255, 0, 0);
			obj.ButtonWartMot6.update();
		});
		obj.ButtonWartMot6.addEventListener("mouseout", func {
			obj.ButtonWartMot6.setColor(0, 0, 0);
			obj.ButtonWartMot6.update();
		});
		obj.ButtonWartMot6.hide();

		obj.uTimer = maketimer(1, func obj.update());
        return obj;
	},
	calcDays : func(seconds)
	{
		var days = math.floor(seconds / (3600 * 24));
		var hours = math.floor((seconds - (days * 3600 * 24)) / 3600);
		var minutes = math.floor((seconds - (days * 3600 * 24) - (hours * 3600)) / 60);
		var retString = sprintf("%i Tage ", days) ~ sprintf("%2i Stunden ", hours) ~ sprintf("%2i Minuten", minutes);
		return retString;
	},
	calcDaysShort : func(seconds)
	{
		var days = math.floor(seconds / (3600 * 24));
		var hours = math.round((seconds - (days * 3600 * 24)) / 3600);
		var retString = sprintf("%i Tage ", days) ~ sprintf("%2i Stunden", hours);
		return retString;
	},
	update : func
    {
		me.DutyIndHull.hide();
		me.ButtonWartHuelle.hide();
		me.DutyIndMot1.hide();
		me.ButtonWartMot1.hide();
		me.DutyIndMot2.hide();
		me.ButtonWartMot2.hide();
		me.DutyIndMot3.hide();
		me.ButtonWartMot3.hide();
		me.DutyIndMot4.hide();
		me.ButtonWartMot4.hide();
		me.DutyIndMot5.hide();
		me.ButtonWartMot5.hide();
		me.DutyIndMot6.hide();
		me.ButtonWartMot6.hide();
		me.StdGesamt.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/hull/total")));
		me.StdEng1.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/engine[0]/total")));
		me.StdEng2.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/engine[1]/total")));
		me.StdEng3.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/engine[2]/total")));
		me.StdEng4.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/engine[3]/total")));
		me.StdEng5.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/engine[4]/total")));
		me.StdEng6.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/engine[5]/total")));
		me.StdFlug.setText(me.calcDays(getprop("/sim/model/L70/hobbs-meter/in-air")));
		var dutycH = getprop("/sim/model/L70/hobbs-meter/hull/dutyc");
		var dutycM1 = getprop("/sim/model/L70/hobbs-meter/engine[0]/dutyc");
		var dutycM2 = getprop("/sim/model/L70/hobbs-meter/engine[1]/dutyc");
		var dutycM3 = getprop("/sim/model/L70/hobbs-meter/engine[2]/dutyc");
		var dutycM4 = getprop("/sim/model/L70/hobbs-meter/engine[3]/dutyc");
		var dutycM5 = getprop("/sim/model/L70/hobbs-meter/engine[4]/dutyc");
		var dutycM6 = getprop("/sim/model/L70/hobbs-meter/engine[5]/dutyc");
		var onGround = getprop("/gear/gear[0]/wow");
		me.DutyHull.setText(me.calcDaysShort(dutycH));
		if (dutycH > 2592000)
		{
			me.DutyIndHull.show();
			if (onGround)
			{
				me.ButtonWartHuelle.show();
			}
		}
		me.DutyMot1.setText(me.calcDaysShort(dutycM1));
		me.DutyMot2.setText(me.calcDaysShort(dutycM2));
		me.DutyMot3.setText(me.calcDaysShort(dutycM3));
		me.DutyMot4.setText(me.calcDaysShort(dutycM4));
		me.DutyMot5.setText(me.calcDaysShort(dutycM5));
		me.DutyMot6.setText(me.calcDaysShort(dutycM6));
		if (dutycM1 > 72000)
		{
			me.DutyIndMot1.show();
			if (onGround)
			{
				me.ButtonWartMot1.show();
			}
		}
		if (dutycM2 > 72000)
		{
			me.DutyIndMot2.show();
			if (onGround)
			{
				me.ButtonWartMot2.show();
			}
		}
		if (dutycM3 > 72000)
		{
			me.DutyIndMot3.show();
			if (onGround)
			{
				me.ButtonWartMot3.show();
			}
		}
		if (dutycM4 > 72000)
		{
			me.DutyIndMot4.show();
			if (onGround)
			{
				me.ButtonWartMot4.show();
			}
		}
		if (dutycM5 > 72000)
		{
			me.DutyIndMot5.show();
			if (onGround)
			{
				me.ButtonWartMot5.show();
			}
		}
		if (dutycM6 > 72000)
		{
			me.DutyIndMot6.show();
			if (onGround)
			{
				me.ButtonWartMot6.show();
			}
		}
	},
	showMDlg : func()
	{
		var dlg = canvas.Window.new([500, 687], "dialog").set("resize", 0).set("title", "Wartung");
		dlg.setCanvas(me.my_canvas);
		me.uTimer.start();
		dlg.owner = me;
		dlg.del = func {
			me.owner.uTimer.stop();
			me.owner.DutyIndHull.hide();
			me.owner.ButtonWartHuelle.hide();
			me.owner.DutyIndMot1.hide();
			me.owner.ButtonWartMot1.hide();
			me.owner.DutyIndMot2.hide();
			me.owner.ButtonWartMot2.hide();
			me.owner.DutyIndMot3.hide();
			me.owner.ButtonWartMot3.hide();
			me.owner.DutyIndMot4.hide();
			me.owner.ButtonWartMot4.hide();
			me.owner.DutyIndMot5.hide();
			me.owner.ButtonWartMot5.hide();
			me.owner.DutyIndMot6.hide();
			me.owner.ButtonWartMot6.hide();
			call(canvas.Window.del, [], me);
		};
	}
};

var BOOK =  BOOK_Device.new("Book", "Book",0);
