var Barograph_Device =
{
	new : func(designation, model_element, model_index=0)
	{
        var obj = {parents : [Barograph_Device] };
        obj.designation = designation;
        obj.model_element = model_element;
		obj.my_canvas = canvas.new({
			"name": designation,   # The name is optional but allow for easier identification
			"size": [1024, 1024], # Size of the underlying texture (should be a power of 2, required) [Resolution]
			"view": [414, 174],  # Virtual resolution (Defines the coordinate system of the canvas [Dimensions]
			"mipmapping": 1       # Enable mipmapping (optional)
		});
		obj.my_canvas.addPlacement({"node": "Display"});
		obj.my_canvas.set("background", "#ffffff");

		obj.root = obj.my_canvas.createGroup();

		var filename = "/Aircraft/L70/Instruments/Hoehenschreiber/Skala.svg";
		obj.svg_symbol = obj.root.createChild('group');
		canvas.parsesvg(obj.svg_symbol, filename);
		obj.path = obj.root.createChild("path").setStrokeLineWidth(1).set("stroke", "rgba(255,0,0)");
		obj.yMin = 10.0;
		obj.yMax = 164.0;
		obj.path.moveTo(0, obj.yMax).lineTo(1, obj.yMax);
		obj.yRange = obj.yMax - obj.yMin;
		obj.altMax = 9000.0 / 0.3048;
		obj.xStep = 414.0 / 43200.0;
		obj.uTimer = maketimer(10, func obj.update());
        return obj;
	},
	init : func
    {
		me.uTimer.start();
	},
	update : func
    {
		var y = getprop("position/altitude-ft") / me.altMax * me.yRange;
		var x = math.fmod(getprop("sim/time/elapsed-sec"), 43200) * me.xStep;
		me.path.lineTo(x, me.yMax - y);
	},
	showMDlg : func()
	{
		var dlg = canvas.Window.new([600, 400], "dialog").set("resize", 0).set("title", "Auswertung Hoehe");
		dlg.setCanvas(me.my_canvas);
	}
};


var Barograph =  Barograph_Device.new("Skala", "Display",0);

setlistener("/sim/signals/fdm-initialized", func { Barograph.init();
});
