###############################################################################
##
## Zeppelin LZ 121 "Nordstern" airship for FlightGear.
## Walk view configuration.
##
##  Copyright (C) 2010 - 2011  Anders Gidenstam  (anders(at)gidenstam.org)
##  This file is licensed under the GPL license v2 or later.
##
###############################################################################

# Constraints
var carBConstraint =
    walkview.makeUnionConstraint(
        [
         walkview.makePolylinePath(
             [
				[143.8, 0.0, -15.30],
				[144.9, 0.0, -15.30],
             ],
             0.60)
        ]);

var carConstraint =
    walkview.makeUnionConstraint(
        [
         walkview.makePolylinePath(
             [
				[25.10,  0.38, -15.2],
				[27.40,  0.38, -15.2],
				[27.40,  0.00, -15.2],
				[28.33,  0.00, -15.2],
				[28.58,  0.26, -15.2],
				[29.12, -0.46, -15.2],
				[29.12, -0.46, -15.2],
				[30.19, -0.46, -15.2],
				[30.19,  0.00, -15.2],
             ],
             0.50),
         walkview.makePolylinePath(
             [
				[25.1, -0.39, -15.2],
				[27.4, -0.39, -15.2],
             ],
             0.50)
        ]);
	
var keelConstraint =
    walkview.makeUnionConstraint(
        [
         walkview.makePolylinePath(
             [
				[ 15.0138, 0.0,  -8.2596],
				[ 22.5107, 0.0,  -9.6559],
				[ 30.0065, 0.0, -10.5726],
				[ 45.0028, 0.0, -11.5272],
				[ 60.0012, 0.0, -11.7363],
				[105.0000, 0.0, -11.7363],
				[119.9980, 0.0, -11.7127],
				[134.9970, 0.0, -11.4030],
				[149.9960, 0.0, -10.6641],
				[164.9940, 0.0,  -9.3947],
             ],
             0.50),
         walkview.makePolylinePath(
             [
				[70.2903, -0.25, -11.7371],
				[70.2903, -4.41801, -10.9753],
				[70.2903, -6.05, -12.9628],
				[70.2903, -6.45, -13.9],
				[69.9000, -6.45, -13.9],
             ],
             0.50),
         walkview.makePolylinePath(
             [
				[70.2903,  0.25, -11.7371],
				[70.2903,  4.41801, -10.9753],
				[70.2903,  6.05, -12.9628],
				[70.2903,  6.45, -13.9],
				[69.9000,  6.45, -13.9],
             ],
             0.50),
         walkview.makePolylinePath(
             [
				[115.806, 0.25, -11.7191],
				[115.806, 1.54467, -11.7173],
				[115.806, 4.1, -13.75],
				[115.806, 4.6, -14.50],
				[115.006, 4.6, -14.50],
             ],
             0.50),
         walkview.makePolylinePath(
             [
				[115.806, -0.25, -11.7191],
				[115.806, -1.54467, -11.7173],
				[115.806, -4.1, -13.75],
				[115.806, -4.6, -14.50],
				[115.006, -4.6, -14.50],
             ],
             0.50)
        ]);

var ladderPosition = [27.4679, 0.601535, -15.5133];
var ladderPosition4 = [144.373,  0.270958, -15.3285];

var climbLadder = func
{
    var walker = walkview.active_walker();
    if (walker != nil)
	{
        var p = walker.get_pos();
        if (math.abs(p[0] - ladderPosition[0]) < 0.5 and math.abs(p[1] - ladderPosition[1]) < 0.5)
		{
            
            if (walker.get_constraints() == keelConstraint)
			{
                walker.set_constraints(carConstraint);
            }
            else
			{
                walker.set_constraints(keelConstraint);
            }
            return;
        }
        if (math.abs(p[0] - ladderPosition4[0]) < 0.5 and math.abs(p[1] - ladderPosition4[1]) < 0.5)
		{
            
            if (walker.get_constraints() == keelConstraint)
			{
                walker.set_constraints(carBConstraint);
            }
            else
			{
                walker.set_constraints(keelConstraint);
            }
            return;
        }
    }
}

var rigger_walker = walkview.Walker.new("Watch Officer View", carConstraint, [walkview.JSBSimPointmass.new(12)]);


